# ARST打卡第250周

<!--more-->

lc589_N叉树的前序遍历 【TED演讲】远程工作真的更好吗？ osd自杀问题跟踪 春运30小时堵车思考

## Algorithm
lc589_N叉树的前序遍历

思路: 直接实现`根左到右`的递归遍历。和昨天的N叉树的BFS不一样的。

下面的思路确实可以秒过，但是整体比较简单的思路，利用了函数栈，
[题解](https://leetcode.cn/problems/n-ary-tree-preorder-traversal/solutions/1317175/n-cha-shu-de-qian-xu-bian-li-by-leetcode-bg99)还可以通过模拟栈来实现.

其中方法三的倒序插入`children`更是妙不可言。推荐看看。

```cpp
/*
// Definition for a Node.
class Node {
public:
    int val;
    vector<Node*> children;

    Node() {}

    Node(int _val) {
        val = _val;
    }

    Node(int _val, vector<Node*> _children) {
        val = _val;
        children = _children;
    }
};
*/

class Solution {
public:
    void preorder_sol(Node* root, vector<int>& ans) {
        if (!root) {
            return ;
        }

        ans.push_back(root->val);
        for (auto& child : root->children) {
            preorder_sol(child, ans);
        }
    }

    vector<int> preorder(Node* root) {
        vector<int> ans;
        preorder_sol(root, ans);
        return ans;
    }
};
```

## Review
【TED演讲】远程工作真的更好吗？

<div align = "center">
    <iframe  width="100%" height="700" src="//player.bilibili.com/player.html?aid=1050713481&bvid=BV1pH4y1E7j4&cid=1442475344&p=1" frameborder="0" allow="autoplay; encrypted-media" allowfullscreen></iframe>
</div>


远程工作真的更好吗? 作者认为分为3个问题:
1. 远程工作的有效性
2. 远程工作能否达成合理的人才配置
3. 远程工作能够维持企业文化

解决好这三个问题，就能确定远程工作是否能更好。


## Tips
[osd自杀问题跟踪](https://github.com/lidaohang/ceph_study/blob/master/%E9%97%AE%E9%A2%98%E4%BF%AE%E5%A4%8D%E3%80%91osd%E8%87%AA%E6%9D%80%E9%97%AE%E9%A2%98%E8%B7%9F%E8%B8%AA.md)

## Share
春运30小时堵车思考

### 经历
在春节最后一天初八高铁票发售的时候就开始抢高铁票。

因为抢到的人和机器太多，导致预选车次功能反而成了自己候补的累赘，每次准备订单中就显示无票了。

导致候补订单在开售3分钟后才下单。

然后当时看候补概率较高，就没有考虑早上和凌晨以及无座的高铁票。

并且当时没有自动候补新增列车功能。

最终一直没有抢到票。。。

可能是因为12306今年官方推出了工人和学生提前2天买票政策，导致票比往年更难抢。

最终自己觉得如果一直硬刚候补，可能要连续请好多天假都没有票，于是多花了几十块联系了滴滴顺风车。


最终滴滴顺风车在春节最后一天堵死，衡阳12小时，郴州8小时，
然后其余时间又堵了10小时，30小时才到深圳出租屋。

人在车上虽然吃了睡了，但是很不舒服，还是拉肚子，并且到家后还是又饿又困...

### 总结教训

1. 多留意政策，出了提前抢票政策，那就尽量使用公司和12306合作的提前抢票
2. 尽量用机器帮忙操作抢票，并且用抢前一天的票充分测试完整
3. 在高峰抢票期不用用预选车票抢购功能
4. 候补不要嫌弃无座，早上，晚上，凌晨，**甚至可以提前几天**，**否则你会在高速路上累死，以至于你几天都是累的**
5. 不要为打翻的牛奶哭泣，向前看，解决当下的问题，尽力改善现状，而不是悔恨当初，接受损失，制定新策略。
6. 开往早晨的**午夜**对我这个乘客来说能顶着巨大声的DJ音乐秒睡，对连续疲劳驾驶的司机是致命的。所以高速有较大生命危险的，还是要尽量轮流开。别让一个司机累死。
7. 反思总结，防止下次再次经历惨痛经历
